﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WarmlyShip
{
    /// <summary>
    /// Класс-сущность "Лайнер"
    /// </summary>
    internal class EntityLiner : EntityShip
    {
        /// <summary>
        /// Дополнительный цвет
        /// </summary>
        public Color DopColor { get; private set; }
        /// <summary>
        /// Признак наличия бассейна
        /// </summary>
        public bool SwimmingPool { get; private set; }
        /// <summary>
        /// Признак наличия дополнительной палубы
        /// </summary>
        public bool DopDeck { get; private set; }

        /// <summary>
        /// Инициализация свойств
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес корабля</param>
        /// <param name="bodyColor">Цвет палубы</param>
        /// <param name="dopColor">Дополнительный цвет</param>
        /// <param name="swimmingPool">Признак наличия бассейна</param>
        /// <param name="dopDeck">Признак наличия дополнительной палубы</param>
        public EntityLiner(int speed, float weight, Color bodyColor, Color dopColor, bool swimmingPool, bool dopDeck) :
            base(speed, weight, bodyColor)
        {
            DopColor = dopColor;
            SwimmingPool = swimmingPool;
            DopDeck = dopDeck;
        }

    }
}
